import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.RepeatedTest;
import org.junit.jupiter.api.RepetitionInfo;
import org.junit.jupiter.api.extension.ExtendWith;

import static org.junit.jupiter.api.Assertions.assertEquals;

@ExtendWith(BankAccountParameterResolver.class)
public class BankAccountRepeatedTestTest {
    @RepeatedTest(5)
    @DisplayName("Deposit 400 successfully")
    void testDeposit(BankAccount bankAccount) {
        bankAccount.deposit(500);
        assertEquals(500.00, bankAccount.getBalance());
    }

    @RepeatedTest(5)
    @DisplayName("Deposit 400 successfully")
    void testDepositRepetitionInfo(BankAccount bankAccount, RepetitionInfo repetitionInfo) {
        bankAccount.deposit(500);
        assertEquals(500.00, bankAccount.getBalance());
        System.out.println("Number : " + repetitionInfo.getCurrentRepetition());
    }
}
